[alacarte/vala+gdesktopmenu] really pass distcheck



commit 97264a3d303e916aef060c43fdc7a33cc142cd48
Author: Travis Watkins <amaranth ubuntu com>
Date:   Wed May 6 23:16:23 2009 -0500

    really pass distcheck
---
 Makefile.am         |   32 +++------
 autogen.sh          |    3 +
 gitlog-to-changelog |  176 +++++++++++++++++++++++++++++++++++++++++++++++++++
 src/Makefile.am     |   32 ++++-----
 4 files changed, 204 insertions(+), 39 deletions(-)

diff --git a/Makefile.am b/Makefile.am
index 29727c7..cff33f3 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -1,7 +1,5 @@
 NULL = 
 
-#Build in these directories:
-
 SUBDIRS = \
 	data \
 	src \
@@ -9,12 +7,8 @@ SUBDIRS = \
 	vapi \
 	$(NULL)
 
-CLEANFILES=
-
 alacartedocdir = ${prefix}/doc/alacarte
 alacartedoc_DATA = \
-	ChangeLog.pre-git \
-	ChangeLog \
 	README \
 	COPYING \
 	AUTHORS \
@@ -24,6 +18,7 @@ alacartedoc_DATA = \
 
 EXTRA_DIST = \
 	$(alacartedoc_DATA) \
+	gitlog-to-changelog \
 	intltool-extract.in \
 	intltool-merge.in \
 	intltool-update.in \
@@ -35,22 +30,17 @@ DISTCLEANFILES = \
 	intltool-merge \
 	intltool-update
 	po/.intltool-merge-cache \
-	ChangeLog \
 	$(NULL)
 
-ChangeLog:
-	@echo Creating $@
-	@if test -d "$(srcdir)/.git"; then \
-	  (GIT_DIR=$(top_srcdir)/.git ./missing --run git log git-migration.. --stat -M -C --name-status  --date=short --no-color) | fmt --split-only > $  tmp \
-	  && mv -f $  tmp $@ \
-	  || ($(RM) $  tmp; \
-	      echo Failed to generate ChangeLog, your ChangeLog may be outdated >&2; \
-	      (test -f $@ || echo git-log is required to generate this file >> $@)); \
-	else \
-	  test -f $@ || \
-	  (echo A git checkout and git-log is required to generate ChangeLog >&2 && \
-	   echo A git checkout and git-log is required to generate this file >> $@); \
-	fi
+dist-hook: gen-ChangeLog
 
-.PHONY: ChangeLog
+gen_start_date = 2009-02-25
+.PHONY: gen-ChangeLog
+gen-ChangeLog:
+	if test -d .git; then						\
+	  $(top_srcdir)/gitlog-to-changelog				\
+	    --since=$(gen_start_date) > $(distdir)/cl-t;		\
+	  rm -f $(distdir)/ChangeLog;					\
+	  mv $(distdir)/cl-t $(distdir)/ChangeLog;			\
+	fi
 
diff --git a/autogen.sh b/autogen.sh
index 04d635f..f8e3179 100755
--- a/autogen.sh
+++ b/autogen.sh
@@ -6,4 +6,7 @@ test -z "$srcdir" && srcdir=.
 
 PKG_NAME="alacarte"
 
+#automake requires ChangeLog to exist
+touch ChangeLog
+
 . gnome-autogen.sh
diff --git a/gitlog-to-changelog b/gitlog-to-changelog
new file mode 100755
index 0000000..d5bc147
--- /dev/null
+++ b/gitlog-to-changelog
@@ -0,0 +1,176 @@
+#!/usr/bin/perl
+# Convert git log output to ChangeLog format.
+
+my $VERSION = '2008-12-21 12:07'; # UTC
+# The definition above must lie within the first 8 lines in order
+# for the Emacs time-stamp write hook (at end) to update it.
+# If you change this file with Emacs, please let the write hook
+# do its job.  Otherwise, update this string manually.
+
+# Copyright (C) 2008 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+# Written by Jim Meyering
+
+use strict;
+use warnings;
+use Getopt::Long;
+use POSIX qw(strftime);
+
+(my $ME = $0) =~ s|.*/||;
+
+# use File::Coda; # http://meyering.net/code/Coda/
+END {
+  defined fileno STDOUT or return;
+  close STDOUT and return;
+  warn "$ME: failed to close standard output: $!\n";
+  $? ||= 1;
+}
+
+sub usage ($)
+{
+  my ($exit_code) = @_;
+  my $STREAM = ($exit_code == 0 ? *STDOUT : *STDERR);
+  if ($exit_code != 0)
+    {
+      print $STREAM "Try `$ME --help' for more information.\n";
+    }
+  else
+    {
+      print $STREAM <<EOF;
+Usage: $ME [OPTIONS] [ARGS]
+
+Convert git log output to ChangeLog format.  If present, any ARGS
+are passed to "git log".  To avoid ARGS being parsed as options to
+$ME, they may be preceded by '--'.
+
+OPTIONS:
+
+   --since=DATE convert only the logs since DATE;
+                  the default is to convert all log entries.
+
+   --help       display this help and exit
+   --version    output version information and exit
+
+EXAMPLE:
+
+  $ME --since=2008-01-01 > ChangeLog
+  $ME -- -n 5 foo > last-5-commits-to-branch-foo
+
+EOF
+    }
+  exit $exit_code;
+}
+
+# If the string $S is a well-behaved file name, simply return it.
+# If it contains white space, quotes, etc., quote it, and return the new string.
+sub shell_quote($)
+{
+  my ($s) = @_;
+  if ($s =~ m![^\w+/.,-]!)
+    {
+      # Convert each single quote to '\''
+      $s =~ s/\'/\'\\\'\'/g;
+      # Then single quote the string.
+      $s = "'$s'";
+    }
+  return $s;
+}
+
+sub quoted_cmd(@)
+{
+  return join (' ', map {shell_quote $_} @_);
+}
+
+{
+  my $since_date = '1970-01-01 UTC';
+  GetOptions
+    (
+     help => sub { usage 0 },
+     version => sub { print "$ME version $VERSION\n"; exit },
+     'since=s' => \$since_date,
+    ) or usage 1;
+
+  my @cmd = (qw (git log --log-size), "--since=$since_date",
+             '--pretty=format:%ct  %an  <%ae>%n%n%s%n%b%n', @ARGV);
+  open PIPE, '-|', @cmd
+    or die ("$ME: failed to run `". quoted_cmd (@cmd) ."': $!\n"
+            . "(Is your Git too old?  Version 1.5.1 or later is required.)\n");
+
+  my $prev_date_line = '';
+  while (1)
+    {
+      defined (my $in = <PIPE>)
+        or last;
+      $in =~ /^log size (\d+)$/
+        or die "$ME:$.: Invalid line (expected log size):\n$in";
+      my $log_nbytes = $1;
+
+      my $log;
+      my $n_read = read PIPE, $log, $log_nbytes;
+      $n_read == $log_nbytes
+        or die "$ME:$.: unexpected EOF\n";
+
+      my @line = split "\n", $log;
+      my $author_line = shift @line;
+      defined $author_line
+        or die "$ME:$.: unexpected EOF\n";
+      $author_line =~ /^(\d+)  (.*>)$/
+        or die "$ME:$.: Invalid line "
+          . "(expected date/author/email):\n$author_line\n";
+
+      my $date_line = sprintf "%s  $2\n", strftime ("%F", localtime ($1));
+      # If this line would be the same as the previous date/name/email
+      # line, then arrange not to print it.
+      if ($date_line ne $prev_date_line)
+        {
+          $prev_date_line eq ''
+            or print "\n";
+          print $date_line;
+        }
+      $prev_date_line = $date_line;
+
+      # Omit "Signed-off-by..." lines.
+      @line = grep !/^Signed-off-by: .*>$/, @line;
+
+      # Remove leading and trailing blank lines.
+      while ($line[0] =~ /^\s*$/) { shift @line; }
+      while ($line[$#line] =~ /^\s*$/) { pop @line; }
+
+      # Prefix each non-empty line with a TAB.
+      @line = map { length $_ ? "\t$_" : '' } @line;
+
+      print "\n", join ("\n", @line), "\n";
+
+      defined ($in = <PIPE>)
+        or last;
+      $in ne "\n"
+        and die "$ME:$.: unexpected line:\n$in";
+    }
+
+  close PIPE
+    or die "$ME: error closing pipe from " . quoted_cmd (@cmd) . "\n";
+  # FIXME-someday: include $PROCESS_STATUS in the diagnostic
+}
+
+# Local Variables:
+# indent-tabs-mode: nil
+# eval: (add-hook 'write-file-hooks 'time-stamp)
+# time-stamp-start: "my $VERSION = '"
+# time-stamp-format: "%:y-%02m-%02d %02H:%02M"
+# time-stamp-time-zone: "UTC"
+# time-stamp-end: "'; # UTC"
+# End:
+
diff --git a/src/Makefile.am b/src/Makefile.am
index 9c7ecb8..74ff347 100644
--- a/src/Makefile.am
+++ b/src/Makefile.am
@@ -4,9 +4,11 @@ AM_CPPFLAGS = \
 	$(ALACARTE_CFLAGS) \
 	$(NULL)
 
-BUILT_SOURCES = alacarte.vala.stamp
+bin_PROGRAMS = \
+	alacarte \
+	$(NULL)
 
-bin_PROGRAMS = alacarte
+BUILT_SOURCES = alacarte.vala.stamp
 
 alacarte_VALASOURCES = \
 	mainwindow.vala \
@@ -26,6 +28,16 @@ alacarte_LDADD = \
 	$(ALACARTE_LIBS) \
 	$(NULL)
 
+EXTRA_DIST = \
+	$(alacarte_VALASOURCES) \
+	alacarte.vala.stamp \
+	config.vala.in \
+	$(NULL)
+
+MAINTAINERCLEANFILES = \
+	$(alacarte_VALASOURCES:.vala=.c) \
+	$(NULL)
+
 config.vala: config.vala.in
 	sed						\
 		-e s!\ prefix\@!$(prefix)!		\
@@ -36,24 +48,8 @@ config.vala: config.vala.in
 		-e s!\ PACKAGE\@!$(PACKAGE)!		\
 		-e s!\ VERSION\@!$(VERSION)!		\
 		< $< > $@
-config.vala: Makefile
-
-EXTRA_DIST = \
-	$(alacarte_VALASOURCES) \
-	alacarte.vala.stamp \
-	config.vala.in \
-	$(NULL)
-
-MAINTAINERCLEANFILES = \
-	$(alacarte_VALASOURCES:.vala=.c) \
-	$(NULL)
 
 CLEANFILES = \
 	config.vala \
 	$(NULL)
 
-all-local: config.vala
-
-DISTCLEANFILES = \
-	$(NULL)
-



[Date Prev][Date Next]   [Thread Prev][Thread Next]   [Thread Index] [Date Index] [Author Index]